//////////////////////////////////////////////////////////////////////
//
// MRC_Comm.h: CMRC_Com NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MRC_COM_H__A841E94C_A2E5_11D5_85B6_005004BAA6B2__INCLUDED_)
#define AFX_MRC_COM_H__A841E94C_A2E5_11D5_85B6_005004BAA6B2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <afxtempl.h>


//////////////////////////////////////////////////////////////////////
//萔`
//////////////////////////////////////////////////////////////////////

#define	BAUDRATE				9600								//Current Baud Rate : 9600 bps
#define	BYTE_SIZE				8									//Data Bit Size		: 8 bit
#define	STOP_BITS				ONESTOPBIT							//Stop Bit			: 1 bit
#define PARITY					0									//Parity			: Non Parity
#define CTS_SENSE				0									//CTS Sense			: On
#define	RW_TIME_OUT				60									//Time Out Interval : 0.5sec.

#define COM_PORT_MAX			10									//LȂbnl|[g
#define COM_PORT_1				0									//	COM Port.1
#define COM_PORT_2				1									//	COM Port.2
#define COM_PORT_3				2									//	COM Port.3
#define COM_PORT_4				3									//	COM Port.4
#define COM_PORT_5				4									//	COM Port.5
#define COM_PORT_6				5									//	COM Port.6
#define COM_PORT_7				6									//	COM Port.7
#define COM_PORT_8				7									//	COM Port.8
#define COM_PORT_9				8									//	COM Port.9
#define COM_PORT_A				9									//	COM Port.10

#define DIAL_VAL_MIN			0									//_CAl
#define DIAL_VAL_MAX			5									//_CAl
#define KEY_VAL_MIN				0									//L[l
#define KEY_VAL_MAX				40									//L[l

#define LED_RED					0									//ԐFkdc
#define LED_GREEN				1									//ΐFkdc
#define LED_IR					2									//ԊOkdc

#define BUF_LEN_MAX				32									//NbTMobt@l`wTCY
#define MRC_COMMENT_LEN_MAX		24									//NbTɐݒ\ȃRgl`wTCY


#define	ENQ						0x05								//ENQ Code
#define	ACK						0x06								//ACK Code
#define	NAK						0x15								//NAK Code


#define CROSSUM_MODE_OLD		1									//NbT[h
#define CROSSUM_MODE_NEW		0									//NbTV[h

#define CROSSUM_ECHO_ON			1									//NbTGR[[hnm
#define CROSSUM_ECHO_OFF		0									//NbTGR[[hnee





//////////////////////////////////////////////////////////////////////
//bQ{R}hXg
//////////////////////////////////////////////////////////////////////

enum ENM_MRC_CmdList {
	MRC_Cmd_LinkCheck = 0,											//ڑ`FbN
	MRC_Cmd_SendSignal,												//VOiM
	MRC_Cmd_DataRead,												//f[^ǂݍ
	MRC_Cmd_DataWrite,												//f[^
	MRC_Cmd_LedCtr,													//kdcRg[
	MRC_Cmd_KeyRead_I,												//L[ǂݏo
	MRC_Cmd_KeyRead_W,												//L[ǂݏo
	MRC_Cmd_ProtectOff,												//[veNg
	MRC_Cmd_Memory,													//ML
	MRC_Cmd_Help,													//ICwv
	MRC_Cmd_Version,												//o[W\
	MRC_Cmd_ECHO,													//GR[ԃgO
	MRC_Cmd_CommentRead,											//Rgǂݏo
	MRC_Cmd_CommentWrite,											//Rg
	MRC_Cmd_ProtectOff2,											//[veNgQ
	MRC_Cmd_GetRawData,												//f[^擾

	MRC_Cmd_Max = MRC_Cmd_GetRawData,								//R}hől
	MRC_Cmd_Num = MRC_Cmd_Max + 1									//R}h
};



//////////////////////////////////////////////////////////////////////
//ʐMW[G[R[h
//////////////////////////////////////////////////////////////////////

enum ENM_MRC_ErrCode {
	MRC_Err_NoError = 0,											//G[
	MRC_Err_ComOpen,												//bnl|[gnG[
	MRC_Err_ComSetting,												//bnl|[gݒG[
	MRC_Err_ComNotOpen,												//bnl|[gb
	MRC_Err_ComDataSend,											//bnl|[gf[^MG[
	MRC_Err_ComDataRead,											//bnl|[gf[^MG[
	MRC_Err_ComDataTimeOut,											//bnl|[gf[^M^CAEg
	MRC_Err_ComPortNo,												//bnl|[gms
	MRC_Err_DialNo,													//w_CAԍs
	MRC_Err_KeyNo,													//wL[ԍs
	MRC_Err_LedNo,													//wkdcԍs
	MRC_Err_RcvBufShort,											//Mwobt@TCYs
	MRC_Err_RcvDataSize,											//Mf[^TCYُ
	MRC_Err_RcvBuf,													//Mf[^obt@ُ
	MRC_Err_SndBufSize,												//Mwobt@TCYُ
	MRC_Err_SndDataSize,											//Mf[^TCYI[o[
	MRC_Err_SndBuf,													//Mwobt@ُ
	MRC_Err_KeyTimeOut,												//L[҂^CAEg
	MRC_Err_SigMemMode,												//MwK[hԕs
	MRC_Err_SigMemTimeOut,											//MwK^CAEg
	MRC_Err_RcvBufAlloc,											//Mobt@AP[gG[
	MRC_Err_SndBufAlloc,											//Mobt@AP[gG[

	MRC_Err_MAX = MRC_Err_SndBufAlloc,
	MRC_Err_Num = MRC_Err_MAX + 1
};





//////////////////////////////////////////////////////////////////////
//ݒf[^pIuWFNg
//////////////////////////////////////////////////////////////////////

#define MRC_SETINFO_COMLEN		64
#define MRC_SETINFO_VERLEN		256

class __declspec(dllexport) CMRC_DataUnit : public CObject
{
///폜֘A
public:
	CMRC_DataUnit();														//IuWFNg쐬
	virtual ~CMRC_DataUnit();												//IuWFNg폜
	virtual void InitObject();												//f[^


//Operation...
public:
	char*			GetComment1();											//RgP擾
	char*			GetComment2();											//RgQ擾
	unsigned char	GetKeyNo();												//L[m擾
	unsigned short	GetSigSize();											//VOif[^TCY擾
	unsigned char*	GetSigData();											//VOif[^擾

	bool			SetComment1(char *pComment);							//RgPݒ
	bool			SetComment2(char *pComment);							//RgQݒ
	bool			SetKeyNo(unsigned char ucKeyNo);						//L[mݒ
	bool			SetSigData(unsigned char *pSigData, int iSize);			//VOif[^ݒ

	void			CopyData(CMRC_DataUnit *pData);							//f[^̂b
	int				WriteData(FILE *pFile);									//f[^̏o
	int				ReadData(FILE *pFile);									//f[^̓



//Data Member...
protected:
	char			m_chComment1[MRC_COMMENT_LEN_MAX];						//RgPiNbTpj
	char			m_chComment2[MRC_SETINFO_COMLEN];						//RgQif[^Rgj
	unsigned char	m_ucKeyNo;												//L[ԍ
	unsigned char	m_ucDmy;												//_~[

	unsigned short	m_usSigSize;											//VOif[^TCY
	unsigned char*	m_pSigData;												//VOif[^

};





//////////////////////////////////////////////////////////////////////
//ݒf[^e[uIuWFNg
//////////////////////////////////////////////////////////////////////

class __declspec(dllexport) CMRC_SetInfo : public CList <CMRC_DataUnit*, CMRC_DataUnit*>
{
///폜֘A
public:
	CMRC_SetInfo();
	virtual ~CMRC_SetInfo();
	void virtual InitObject();



//Operation...
public:
	char*			GetVersion();											//o[W̎擾
	char*			GetComment();											//Rg̎擾
	int				GetDataNum();											//f[^̎擾

	CMRC_DataUnit*	GetData2Pos(int iPos);									//w肵ʒũf[^擾
	CMRC_DataUnit*	GetData2Key(int iKey);									//w肵L[mf[^擾
	bool			AddData(CMRC_DataUnit *pData);							//w肵f[^bĒǉ
	bool			RmvData(CMRC_DataUnit *pData);							//w肵f[^폜
	bool			RmvPos(int iPos);										//w肵ʒũf[^폜
	bool			RmvKey(int iKey);										//w肵L[f[^폜

	bool			SaveData(char *pFileName);								//ݒf[^o
	bool			LoadData(char *pFileName);								//ݒf[^




//Data Member...
protected:
	char			m_chVersion[MRC_SETINFO_VERLEN];						//o[W
	char			m_chComment[MRC_COMMENT_LEN_MAX];						//Rg
};








//////////////////////////////////////////////////////////////////////
//ʐMW[IuWFNg
//////////////////////////////////////////////////////////////////////

class __declspec(dllexport) CMRC_Com : public CObject  
{
public:
	CMRC_Com();														//Object Create...
	virtual ~CMRC_Com();											//Object Delete...

	void Init_Object();												//Data Initalize...





//Operation...
public:
	bool Init_Comm(int iComNo);										//ʐMibnl|[gj
	bool Open(int iComNo = 0);										//ʐM|[gn
	bool Close();													//ʐM|[gb

	bool CrosSumReSet();											//NbTZbg
	bool CrosSumLinkTest();											//NbTڑeXg
	bool SendSignal(int iDial, int iKey);							//w肳ꂽM𔭐M
	bool StopSignal();												//VOiM~
	bool SendSignal2(int iDial, int iKey, int iWait);				//w肵ԃVOiAMiubNj
	int  DataRead(int iDial, int iKey, char *pBuf, int iBufSize);	//f[^ǂݏo
	bool DataWrite(int iDial, int iKey, char *pBuf, int iLength);	//f[^
	bool DataDelete(int iDial, int iKey);							//f[^̏
	bool SetLED_State(int iLED_No, bool bState);					//kdc̓_/𐧌䂷
	bool GetKeyCodeWait(int *pCode, int iCnt = 99);					//ꂽL[擾iL[܂ŏ̓ubNj
	bool GetKeyCodeLast(int *pCode);								//ŌɉꂽL[擾
	bool ProtectOff();												//NbT̃veNg
	bool SetSigMemmory(int iDial, int iKey, int iCnt = 99);			//MwK
	bool GetHelp(char *pBuf, int iBufSize);							//ICwvǂݏo
	bool GetVersion(char *pBuf, int iBufSize);						//o[Wǂݏo
	int	 EchoToggle();												//GR[ԃgO
	bool GetComment(int iDial, int iKey, char *pBuf, int iBufSize);	//Rgǂݏo
	bool SetComment(int iDial, int iKey, char *pBuf);				//Rgݒ
	bool DelComment(int iDial, int iKey);							//Rg
	bool ProtectOff2();												//veNgnee
	bool GetRawData(char *pBuf, int iBufSize);						//f[^擾
	bool GetSetInfo(CMRC_SetInfo *pInfo, int iDialNo);				//ݒf[^̎擾
	bool SetSetInfo(CMRC_SetInfo *pInfo, int iDialNo);				//ݒf[^̏

	int  GetLadtError() { return m_iErrNo;	}						//G[Ԃ̎擾




//COM Parameter Setting...
	bool SetBaudRate(int iRate);									//{[[gݒ
	bool SetByteSize(int iSize);									//oCgTCYݒ
	bool SetStopBit(int iSize);										//XgbvrbgTCYݒ
	bool SetParity(bool bStat);										//peB L or  ݒ
	bool SetTimeOutCount(int iCount);								//^CAEgJEgݒ

	int  GetBaudRate();												//{[[g擾
	int  GetByteSize();												//oCgTCY擾
	int  GetStopBit();												//XgbvrbgTCY擾
	bool GetParity();												//peB L or  擾
	int  GetTimeOutCount();											//^CAEgJEg擾




//COM Port Read/Write Function...
protected:
	int		DataSend_BIN(char *pData, int iDataLen);				//f[^M ` w肳ꂽTCYf[^𑗐M
	int		DataRead_BIN(char *pData, int iSize);					//f[^M ` w肳ꂽTCYf[^M
	int		DataSend_TXT(char *pData, int iDataLen = -1);			//f[^M ` w肳ꂽ𑗐MiI[ɂbq^keǉ)
	int		DataRead_TXT(char *pData, int iSize);					//f[^M ` bq^keo܂Ńf[^M
	int		DataRead_TXW(char *pData, int iSize, int iCnt = -1);	//f[^M ` bq^keo܂Ńf[^҂Â

	void	ReadBufClr(int iSize = -1);								//f[^Mobt@NA
	char*	GetCmdStr(int iCmdNo);									//eR}hɑΉ镶擾

	bool	CrosSumChk();											//NbTb
	int		CrosSumChk_Echo();										//NbT̃GR[[hb
	int		CrosSumChk_Mode();										//NbT̓샂[hb


//Data Member...
protected:
	HANDLE		m_hdCom;											//COM Line ւ HANDLED
	int			m_iComNo;											//Open Ă Com No...
	int			m_iMode;											//NbT샂[h
	int			m_iEcho;											//GR[[h
	int			m_iErrNo;											//G[R[h

	int			m_iBaudRate;										//{[[g
	int			m_iByteSize;										//oCgTCY
	int			m_iStopBit;											//Xgbvrbg
	int			m_iParity;											//peBL/
	int			m_iTimeOutCount;									//^CAEgJEg
};

#endif // !defined(AFX_MRC_COM_H__A841E94C_A2E5_11D5_85B6_005004BAA6B2__INCLUDED_)
